Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
TTMAC_Base Class Reference

TTMAC message authentication code information. More...

Inheritance diagram for TTMAC_Base:

## Public Member Functions
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
void | UncheckedSetKey (const byte *userKey, unsigned int keylength, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation. More...
void | TruncatedFinal (byte *mac, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from IteratedHash< word32, LittleEndian, 64, MessageAuthenticationCode >
unsigned int | BlockSize () const
| Provides the block size of the hash. More...
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash. More...
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash. More...
Public Member Functions inherited from IteratedHashBase< word32, MessageAuthenticationCode >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const =0
| Returns default key length. More...
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm. More...
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions
static std::string | StaticAlgorithmName ()
Static Public Member Functions inherited from FixedKeyLength< 20 >
static size_t | StaticGetValidKeyLength (size_t keylength)
| The default key length for the algorithm provided by a static function. More...

## Static Public Attributes
static const int | DIGESTSIZE =20
Static Public Attributes inherited from FixedKeyLength< 20 >
static const int | KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant. More...
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant. More...
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant. More...
static const int | IV_LENGTH
| The default IV length used by the algorithm provided as a constant. More...
Static Public Attributes inherited from IteratedHash< word32, LittleEndian, 64, MessageAuthenticationCode >
static const int | BLOCKSIZE

## Additional Inherited Members
Public Types inherited from IteratedHash< word32, LittleEndian, 64, MessageAuthenticationCode >
typedef LittleEndian | ByteOrderClass
typedef word32 | HashWordType
Public Types inherited from IteratedHashBase< word32, MessageAuthenticationCode >
typedef word32 | HashWordType
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

TTMAC message authentication code information.

Definition at line 16 of file ttmac.h.

## Member Function Documentation

## ◆ DigestSize()

unsigned int TTMAC_Base::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 22 of file ttmac.h.

## ◆ UncheckedSetKey()

void TTMAC_Base::UncheckedSetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params
| ) |  |
| virtual

Sets the key for this object without performing parameter validation.

Parameters

  key | a byte buffer used to key the cipher
  length | the length of the byte buffer
  params | additional parameters passed as NameValuePairs

key must be at least DEFAULT_KEYLENGTH in length.

Implements SimpleKeyingInterface.

Definition at line 43 of file ttmac.cpp.

## ◆ TruncatedFinal()

void TTMAC_Base::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 62 of file ttmac.cpp.

The documentation for this class was generated from the following files:

- ttmac.h
- ttmac.cpp